import numpy as np

import importlib

from utils import *
from linear_utils import *
import expt_utils as expt_utils
# importlib.reload(expt_utils)


algos_dict = {
  'IDS': [IDS_linear, {"M": 100}, 10, 'IDS', '-sm'],
  'TS': [TS_linear, {}, 10, 'TS', '-ob'],
  'UCB': [UCB_linear, {}, 10, 'UCB', '-y^'],
  'Random': [linear_solver, {}, 10, 'Random', '-sg']
}

prob_dict = {
  "m": 500,
  "noise": 1.0,
  "d": [5, 20, 50, 100]
}

script_file = 'expt_linear.py'

# expt_utils.algos_metrics(
#     prob_dict, algos_dict, linear_discover, T = 500,
#     results_dir='results/linear/', script_file=script_file
#     )

expt_utils.algos_vs_var_metrics(
    prob_dict, algos_dict, linear_discover, T = 500,
    results_dir='results/linear/', script_file=script_file
    )
